import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DataInfo extends JPanel
{  protected static String[] DRIVER_TEXT =    {"Connect to MySQL Server", 
                                             "Connect to IBM DB2 Server"};
   protected static String[] DRIVER_PREFACE = {"jdbc:mysql://",
                                             "jdbc:db2://"};
   protected static String[] DRIVER_CLASS =   {"org.gjt.mm.mysql.Driver",
                                             "COM.ibm.db2.jdbc.net.DB2Driver"};

   protected static String BUTTONS[] = { "Connect", "Cancel" };
   protected static String TITLE    = "Connection Information";
   private JButton    cancel    = new JButton("Cancel");
   private JTextField hostField = new JTextField(17);
   private JTextField dataField = new JTextField(10);
   private JTextField userField = new JTextField("anonymous");
   private JPasswordField pswdField = new JPasswordField("no password");
   private JTextField portField = new JTextField("####");
   private JComboBox  servField = new JComboBox(DRIVER_TEXT);

   public DataInfo(String host, String data, String user, String pswd, String port)
   {  JPanel labels = new JPanel(new GridLayout(6,1));
      labels.add(new JLabel("Host: ", JLabel.RIGHT));
      labels.add(new JLabel("Database: ", JLabel.RIGHT));
      labels.add(new JLabel("Username: ", JLabel.RIGHT));
      labels.add(new JLabel("Password: ", JLabel.RIGHT));
      labels.add(new JLabel("Port: ", JLabel.RIGHT));
      labels.add(new JLabel("Server: ", JLabel.RIGHT));
 
      JPanel fields = new JPanel(new GridLayout(6,1));
      fields.add(hostField); hostField.setText(host);
      fields.add(dataField); dataField.setText(data);
      fields.add(userField); userField.setText(user);
      fields.add(pswdField); pswdField.setText(pswd);
      fields.add(portField); portField.setText(port);
      fields.add(servField); 

      setFont(new Font("Helvetica", Font.BOLD, 12));
      setLayout(new BorderLayout());
      add("West", labels);
      add("Center", fields);
   }
   public String[] getInfo()
   {  String string[] = new String[5];
      string[0] = hostField.getText().trim();
      string[1] = dataField.getText().trim();
      string[2] = userField.getText().trim();
      string[3] = new String(pswdField.getPassword()).trim();
      string[4] = portField.getText().trim();
      return string;
   }
   public int getDriverIndex()
   {  return servField.getSelectedIndex();
   }
}
