import java.sql.SQLException;
import java.awt.event.*;
import javax.swing.*;

public class DataViewerMenu extends JMenuBar implements ActionListener
{   private JMenuItem fileExit = new JMenuItem("Exit");

    private JMenuItem fileOpen = new JMenuItem("Connect ...");
    private JMenuItem fileClose = new JMenuItem("Disconnect");

    private JMenuItem fileImport = new JMenuItem("Import ...");
    private JMenuItem fileExport = new JMenuItem("Export ...");

    private JMenuItem dataAdd = new JMenuItem("New Row");
    private JMenuItem dataEdit = new JMenuItem("Edit/Delete Row");

    private DataViewer parent = null;

    public DataViewerMenu(DataViewer parent)
    {  super();
       this.parent = parent;

       JMenu fileMenu = new JMenu("File");

        addItem(fileMenu, fileOpen);
        addItem(fileMenu, fileClose);
        fileMenu.addSeparator();
        addItem(fileMenu, fileImport);
        addItem(fileMenu, fileExport);
        fileMenu.addSeparator();
       addItem(fileMenu, fileExit);

       JMenu editMenu = new JMenu("Edit");

       JMenu dataMenu = new JMenu("Data");
       addItem(dataMenu, dataAdd);
       addItem(dataMenu, dataEdit);

       JMenu helpMenu = new JMenu("Help");

       add(fileMenu);
       add(editMenu);
       add(dataMenu);
       add(helpMenu);
 
       dataEdit.setEnabled(false);
        setTransferEnabled(false);
        setConnected(false);
   }

    public void setConnected(boolean state)
    {   fileOpen.setEnabled(!state);
        fileClose.setEnabled(state);
    } 

    public void setTransferEnabled(boolean state)
    {   fileImport.setEnabled(state);
        fileExport.setEnabled(state);
    }

    public void actionPerformed(ActionEvent ae)
    {  if (ae.getSource() == fileExit)
          parent.exit();
        else if (ae.getSource() == fileOpen)
            parent.showTables();
        else if (ae.getSource() == fileClose)
        {   try
            {   parent.disconnect();
            }
            catch(SQLException sqle)
            {   JOptionPane.showMessageDialog(parent, "Error disconnecting: " + sqle.getMessage());
            }
            finally
            {   setTransferEnabled(false);
                setConnected(false);
            }
        }
        else if (ae.getSource() == fileImport)
            parent.importData();
        else if (ae.getSource() == fileExport)
            parent.exportData();
       else if (ae.getSource() == dataAdd)
          parent.addNewRow();
       else if (ae.getSource() == dataEdit)
          parent.editRow();
    }

    private void addItem(JMenu menu, JMenuItem item)
    {  menu.add(item);
       item.addActionListener(this);
    }
}
