import java.sql.*;
import java.util.*;
// import javax.swing.JOptionPane;
import javax.swing.table.*;

public class SQLTableModel extends AbstractTableModel 
{  protected final static int MAX_ROW_COUNT = 2000;

   private Vector titles;
   private Vector data;
   private ResultSet results;
   /* ********************************************************************************** */
   public SQLTableModel()
   {  titles = new Vector();
      data   = new Vector();
   }
   /* ********************************************************************************** */
   public ResultSet getResults() throws SQLException
   {  if (results != null)
         return results;
      else
         throw new SQLException("No results yet. Get table data first, then try again.");
   }
   /* ********************************************************************************** */
   public Vector getRow(int i) throws SQLException
   {  if (i >= 0)
         return (Vector)data.get(i);
      else
         throw new SQLException("No row selected.");
   }
   /* ********************************************************************************** */
   public void setResults(ResultSet results) throws SQLException
   {  this.results = results;
      titles = new Vector();
      data = new Vector();
      int rowCount = 0;
      Vector row = new Vector();
      if (results.next())
      {  for (int i = 0; i < results.getMetaData().getColumnCount(); i++)
         {  titles.add(results.getMetaData().getColumnName(i+1));
            row.add(results.getString(i+1));
         }
         rowCount++;
         data.add(row);
         while ((results.next()) && (rowCount < MAX_ROW_COUNT))
         {  row = new Vector();
            for (int i = 0; i < results.getMetaData().getColumnCount(); i++) 
               row.add(results.getString(i+1));
            data.add(row);
            rowCount++;
         }
      }
      fireTableStructureChanged();
      fireTableDataChanged();
      if (rowCount >= MAX_ROW_COUNT)
         throw new SQLException("Only first " + rowCount + " rows listed!<br>Use 'where' clause or export table to see more.");
   }
   /* ********************************************************************************** */
   public int getColumnCount() 
   {  return titles.size();
   }
   /* ********************************************************************************** */
   public int getRowCount() 
   {  return data.size();
   }
   /* ********************************************************************************** */
   public String getColumnName(int col) 
   {  return titles.elementAt(col).toString();
   }
   /* ********************************************************************************** */
   public Object getValueAt(int row, int col) 
   {  return ((Vector)(data.elementAt(row))).elementAt(col);
   }
   /* ********************************************************************************** */
   public boolean isCellEditable(int row, int col) 
   {  return false;
   }
   /* ********************************************************************************** */
}
